% TODO: these are swipl only, find a way to make these two portable
:- set_prolog_flag(last_call_optimisation, true).
:- set_prolog_flag(stack_limit, 32 000 000 000).

:- use_module(library(http/json)).

% Constants
% TODO: hwTh is stuff from old placer; to be removed
:- discontiguous(hwTh/1).
hwTh(0).

% Portability
:- discontiguous(dif/2).
dif(A,B) :- A \== B.

:- discontiguous(writeln/1).
writeln(W) :- write(W), nl.


:- dynamic(affinity/1).
:- dynamic(antiAffinity/1).
:- dynamic(xAffinity/2).
:- dynamic(xAntiAffinity/2).

:- discontiguous(affinity/1).
:- discontiguous(antiAffinity/1).
:- discontiguous(xAffinity/2).
:- discontiguous(xAntiAffinity/2).

% Add placement list to result dict (using warmstart format)
add_P(Dict, [L|Ist], NewDict) :-
    term_to_atom(L, A),
    put_dict(A, Dict, 1, TmpDict),
    add_P(TmpDict, Ist, NewDict).
add_P(Dict, [], Dict).
